package Go;

import Go.strategy.*;

public class AtariGoPlayerCho extends Player {

  public AtariGoPlayerCho(int color, GoStrategy strategy) {
    super(color);
    this.strategy = strategy;
  }

  // override Player's initPlayer method
  public void initPlayer() {}

  // Methods declared in GoGameListener interface,
  // implemented by Player
  public void positionChanged(GoGameEvent goGameEvent) {}
  public void gameOver(GoGameEvent goGameEvent) {}

  // override Player's move method
  protected Move move(GoPosition goPosition) {
    return strategy.chooseNextMove(goPosition);
  }

  protected GoStrategy strategy;
}