package Go;

import java.awt.Toolkit;

public class HumanGoPlayer extends Player implements Runnable, MoveInputDeviceListener {

  public HumanGoPlayer(int color) {
    super(color);

    //newMove = new Move(color);
  }

  public void initPlayer() {}

  public void run() {
    // wait until a new attempt to play a move is made
    /*newMove = null;

    while (newMove == null)
      try {
        Thread.currentThread().sleep(100);
      } catch (InterruptedException ie) {
          System.err.println("Thread interrupted exceptinon in HumanGoPlayer: " + ie);
        }*/
  }

  protected Move move(GoPosition goPosition) {
    // here we should start a thread which monitors an input device
    // (mouse, etc.) to catch the moment when the player makes his move
    boolean newMoveMadeOK = false;
    newMove = null;

    while (newMoveMadeOK == false) {
      //new Thread(this).start();

      while (newMove == null)
        try {
          Thread.currentThread().sleep(100);
        } catch (InterruptedException ie) {}

      newMove.color = this.color;

      // if we are here a new move attempt was made
      // check if it is a legal move
      if (goPosition.isLegalMove(newMove)) {
        newMoveMadeOK = true;
      }
      else {
        illegalMoveAnnouncement();
        newMove = null;
      }
    }
    return newMove;
  }

  public void setGame(GoGame game) {
    this.game = game;
  }

  // MoveInputDeviceListener interface method
  public void moveAttempt(Move move) {
    move.color = this.color;
    newMove = move;
  }

  public void positionChanged(GoGameEvent goGameEvent) {}
  public void gameOver(GoGameEvent goGameEvent) {}

  private void illegalMoveAnnouncement() {
    /*try {
    Toolkit.getDefaultToolkit().beep();
    } catch (Exception e) {}*/
  }

  //protected MoveInputDevice moveInputDevice;

  private boolean newMoveInput = false;
  private Move newMove = null;

  /*class WaitThread extends Thread {
    public void run() {

    }
  } */
}